'' =================================================================================================
''
''   File....... LidarLiteDemmo.spin
''   Purpose.... Simple demo of LIDAR Lite Range Finder object
''   Author..... John Abshier (jabshier on Parallax Forum)
''               -- see below for terms of use
''   E-mail..... jabshier@kc.rr.com
''   Version.... 1.0 19 March 2015 Initial program
''               1.1 10 March 2015 Added support to read ambient light sensor
''
'' =================================================================================================
 

con

  _clkmode = xtal1 + pll16x
  _xinfreq = 5_000_000                                          ' use 5MHz crystal
' _xinfreq = 6_250_000                                          ' use 6.25MHz crystal

  CLK_FREQ = ((_clkmode - xtal1) >> 6) * _xinfreq
  MS_001   = CLK_FREQ / 1_000
  US_001   = CLK_FREQ / 1_000_000


con

  RX1 = 31                                                      ' programming / terminal
  TX1 = 30
  
  SDA = 2                                                      ' VL6180 / i2c
  SCL = 1                                                      ' I2C address of LIDAR-Lite

con

   #1, HOME, GOTOXY, #8, BKSP, TAB, LF, CLREOL, CLRDN, CR       ' PST formmatting control
  #14, GOTOX, GOTOY, CLS 

{ To do:  Implement 3 element median filter for shot noise
          Implement filters for range and velocity
          Make a back ground version that runs in its own cog
          Add a zero function
          Read other registers
          Test range and velocity
          Speed it up    }
obj

  term   : "fullduplexserial"                                 ' for terminal
  Rng    : "LidarLite"                                        ' ranger object


pub main  | i , offset

  term.start(RX1, TX1, %0000, 115_200)                          ' start terminal I/O
  term.rxflush                                                   ' wait open terminal & keypress
  term.rx
  term.tx(CLS)                                                        
  Rng.SetupI2cBus(SCL, SDA)
  Rng.ResetToDefault

  repeat   256
     term.dec(Rng.GetCentimeters)
     term.tx(CR)
  Rng.SetupFilter(5)
  term.dec(999999)
  term.tx(CR)
  repeat 256
      term.dec(Rng.GetCentimetersFiltered)
      term.tx(CR)    
{{

  Terms of Use: MIT License

  Permission is hereby granted, free of charge, to any person obtaining a copy of this
  software and associated documentation files (the "Software"), to deal in the Software
  without restriction, including without limitation the rights to use, copy, modify,
  merge, publish, distribute, sublicense, and/or sell copies of the Software, and to
  permit persons to whom the Software is furnished to do so, subject to the following
  conditions:

  The above copyright notice and this permission notice shall be included in all copies
  or substantial portions of the Software.

  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED,
  INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A
  PARTICULAR PURPOSE AND NON-INFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT
  HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF
  CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE
  OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.

}}